=== debian/changelog ===
powdertoy (83.9-maemo1) unstable; urgency=low

  * New upstream release	
  * Resolution
  * Always fullscreen + hud

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Mon, 15 Oct 2012 12:36:31 +0020

powdertoy (57-maemo1) unstable; urgency=low
	
  * Resolution
  * Always fullscreen + hud

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Mon, 22 Aug 2011 20:34:31 +0020
