=== debian/changelog ===
powdertoy (88.1-maemo2) unstable; urgency=low

  * building with python2.5 and scons2-opt	

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Fri, 02 Aug 2013 10:08:31 +0200

powdertoy (88.1-maemo1) unstable; urgency=low

  * New upstream release	
  * Fullscreen (kiosk)

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Wed, 31 Jul 2013 13:03:31 +0200
