=== debian/control ===
Source: powdertoy
Section: user/games
Priority: optional
Maintainer: Aapo Rantalainen <aapo.rantalainen@gmail.com>
Build-Depends: debhelper (>> 5.0.0), libsdl1.2-dev, libfftw3-dev, libbz2-dev, liblua5.1-0-dev, scons2-opt, python2.5, zlib1g-dev
Standards-Version: 3.7.2
Homepage: http://powdertoy.co.uk/
XSBC-Bugtracker: mailto:aapo.rantalainen@gmail.com

Package: powdertoy
Architecture: any
Depends: ${shlibs:Depends}
Description: Falling sand physics sandbox game, with air pressure, velocity and heat
