=== debian/rules ===
--- 
+++ 
@@ -28,21 +28,6 @@
 	CPPFLAGS += -DNDEBUG
 endif
 
-#maemo
-ifneq (,$(findstring arm-linux,$(DEB_BUILD_GNU_TYPE)))
-	CPPFLAGS += -fomit-frame-pointer
-	#internal compiler error under maemo scratchbox
-        #CPPFLAGS += -frename-registers
-	CPPFLAGS += -ffast-math
-	#omap2
-#	CPPFLAGS += -mcpu=arm1136j-s -mfpu=vfp -mfloat-abi=softfp 
-	#omap3
-#	CPPFLAGS += -mcpu=cortex-a8 -mfpu=vfp3 -mfloat-abi=softfp 
-	CPPFLAGS += -mcpu=cortex-a8 -mfpu=neon -mfloat-abi=softfp
-	CPPFLAGS += -ftree-vectorize -fsingle-precision-constant
-endif
-
-
 
 config.status: configure
 	dh_testdir
@@ -55,7 +40,7 @@
 	dh_testdir
 
 	# Add here commands to compile the package.
-	make powder-maemo
+	/usr/bin/python2.5 /opt/scons2/bin/scons --lin --release
 	touch build-stamp
 
 clean: config.status
@@ -64,7 +49,7 @@
 	rm -f build-stamp
 
 	# Add here commands to clean up after the build process.
-	make clean
+	rm -rf build
 	dh_clean
 
 install: build
@@ -79,11 +64,11 @@
 	CURDIR=$1
 
 	install -d  ${CURDIR}/debian/powdertoy/opt/powdertoy
-	install ${CURDIR}/build/powder-maemo ${CURDIR}/debian/powdertoy/opt/powdertoy/powdertoy
+	install ${CURDIR}/build/powder-legacy ${CURDIR}/debian/powdertoy/opt/powdertoy/powdertoy
 
 	#menu and icon
 	install -d  ${CURDIR}/debian/powdertoy/usr/share/pixmaps 
-	install ${CURDIR}/src/Resources/Icon-32.png  ${CURDIR}/debian/powdertoy/usr/share/pixmaps/powdertoy.png
+	install ${CURDIR}/debian/Icon-32.png  ${CURDIR}/debian/powdertoy/usr/share/pixmaps/powdertoy.png
 
 	install -d ${CURDIR}/debian/powdertoy/usr/share/applications/hildon
 	install ${CURDIR}/debian/powdertoy.desktop ${CURDIR}/debian/powdertoy/usr/share/applications/hildon
